define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for MapaUsuario generated by Appery.io
         * @module MapaUsuario
         */
        APP.controller('MapaUsuario', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.userLocal = Apperyio.EntityAPI('User');
            $scope.customMarkers = Apperyio.EntityAPI('String');
            $scope.gpsRecentList = Apperyio.EntityAPI('GpsRecentList');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                var $routeParams = Apperyio.get('$routeParams');
                //$scope.idUsuario = $routeParams.idUsuario;
                $scope.idUsuario = "rodrigogonzalez@diggital.cl";
                //Cargar las ubicaciones del técnico
                setTimeout(function() {
                    $scope.updateLocations();
                }, $scope.timeReloadLocations);
                if (localStorage.getItem("customMarkers_" + $scope.idUsuario)) {
                    $scope.customMarkers = JSON.parse(localStorage.getItem("customMarkers_" + $scope.idUsuario));
                } else {
                    $scope.customMarkers = $scope.sampleMarkers
                    localStorage.setItem("customMarkers_" + $scope.idUsuario, JSON.stringify($scope.customMarkers));
                }
                $scope.map = {
                    zoom: 12,
                    center: {
                        latitude: -33.447487,
                        longitude: -70.673676
                    },
                    control: {}
                }
                $scope.updateLocations();
            };
            /**
             * @function salir
             */
            $scope.salir = function() {
                localStorage.clear();
                Apperyio.navigateTo("Home", {});
            };
            /**
             * @function updateLocations
             */
            $scope.updateLocations = function() {
                $scope.showLoading("Actualizando ubicaciones...");
                var requestData = {};
                requestData = (function mapping5882($scope) {
                    var requestData = {};
                    requestData.params = {};
                    var customMarkers_scope = $scope.customMarkers;
                    requestData.params.where = {
                        usuario: $scope.idUsuario
                    };
                    requestData.params.sort = "-_updatedAt";
                    return requestData;
                    /*|button_mapping|onbeforesend|6D9F8C5E-B91D-9B5E-ECD6-993C2484F3DB||5882|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_GPS_query_service")(requestData).then( /*|service_bookmark|bookmark|6D9F8C5E-B91D-9B5E-ECD6-993C2484F3DB||3944|*/
                    function(success) { // success callback
                        (function mapping4846(success, $scope) {
                            var markerListTemp = [];
                            var gpsRecentList_scope = $scope.gpsRecentList;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(gpsRecentList_scope, '[' + i + '].latitud', success.data[i].latitud);
                                _.set(gpsRecentList_scope, '[' + i + '].longitud', success.data[i].longitud);
                                _.set(gpsRecentList_scope, '[' + i + '].usuario', success.data[i].usuario);
                                _.set(gpsRecentList_scope, '[' + i + '].deviceid', success.data[i].deviceid);
                                _.set(gpsRecentList_scope, '[' + i + '].posHist', success.data[i].posHist);
                                _.set(gpsRecentList_scope, '[' + i + '].idCliente', success.data[i].posHist);
                                _.set(gpsRecentList_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(gpsRecentList_scope, '[' + i + '].fechaHora', success.data[i].fechaReporte);
                                markerTmp = {
                                    id: success.data[i]._id,
                                    latitude: success.data[i].latitud,
                                    longitude: success.data[i].longitud,
                                    hour: success.data[i]._updatedAt,
                                    options: {
                                        draggable: false
                                    },
                                    idUser: success.data[i].usuario,
                                    fullName: success.data[i].usuario,
                                    fechaHora: getFullTime(success.data[i].fechaReporte),
                                    posHist: JSON.parse(success.data[i].posHist),
                                    status: "60%"
                                };
                                markerListTemp.push(markerTmp);
                            }
                            $scope.gpsRecentList = gpsRecentList_scope;
                            /*|button_mapping|onsuccess|6D9F8C5E-B91D-9B5E-ECD6-993C2484F3DB||4846|*/
                            $scope.customMarkers = filterLastMarkers(markerListTemp);
                            localStorage.setItem("customMarkers_" + $scope.idUsuario, JSON.stringify(filterLastMarkers(markerListTemp)));
                            $scope.stopLoading();
                        })(success, $scope);
                        setTimeout(function() {
                            $scope.updateLocations();
                        }, $scope.timeReloadLocations);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        setTimeout(function() {
                            $scope.updateLocations();
                        }, $scope.timeReloadLocations);
                        alert("Hubo errores al actualizar las posiciones GPS: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function filterLastMarkers
             * @param markerList
             */
            function filterLastMarkers(markerList) {
                if (markerList && markerList.length > 0) {
                    //Filtrar la lista markerList dejando sólo un punto por usuario, el más reciente
                    var arrayTempo = [];
                    for (var i in markerList) {
                        if (markerList[i].posHist && markerList[i].posHist.length > 0) {
                            a1 = markerList[i].posHist;
                            for (var j in a1) {
                                var elem = {
                                    id: i + "-" + j,
                                    latitude: a1[j].latitude,
                                    longitude: a1[j].longitude,
                                    options: {
                                        draggable: false
                                    },
                                    fullName: markerList[i].fullName,
                                    fechaHora: getFullTime(a1[j].gpsDate)
                                };
                                arrayTempo.push(elem);
                            }
                        }
                    }
                    return arrayTempo;
                } else {
                    return [];
                }
            };
            /**
             * @function getFullTime
             * @param date
             */
            function getFullTime(date) {
                if (date) {
                    a = date.split(" ");
                    b0 = a[0].split("-");
                    b1 = a[1].split(":");
                    return b0[2] + "/" + b0[1] + " " + b1[0] + ":" + b1[1];
                } else {
                    return "01-01 00:00"
                }
            };
            /**
             * @function goToMapaUsuario
             * @param idUsuario
             */
            $scope.goToMapaUsuario = function(idUsuario) {
            };
        }
    });